#include <mega128.h>
#include <spi.h>
#include <string.h>
#include <delay.h>
#include <stdio.h>
#include <stdlib.h>  //      itoa( , )

#include "fonts.h"
#include "lcd_s65.h"

//      
#define RS      PORTB.1
#define RESET   PORTB.0
#define CS      PORTB.4
//     
//    SPI 

// INIT1: ; 24bytes
flash char disctl[9]={0x4C, 0x01, 0x53, 0x00, 0x02, 0xB4, 0xB0, 0x02, 0x00};
flash char gcp64_0[29]={0x11,0x27,0x3C,0x4C,0x5D,0x6C,0x78,0x84,0x90,0x99,0xA2,0xAA,0xB2,0xBA,
  0xC0,0xC7,0xCC,0xD2,0xD7,0xDC,0xE0,0xE4,0xE8,0xED,0xF0,0xF4,0xF7,0xFB,
  0xFE};
flash char gcp64_1[34]={0x01,0x03,0x06,0x09,0x0B,0x0E,0x10,0x13,0x15,0x17,0x19,0x1C,0x1E,0x20,
  0x22,0x24,0x26,0x28,0x2A,0x2C,0x2D,0x2F,0x31,0x33,0x35,0x37,0x39,0x3B,
  0x3D,0x3F,0x42,0x44,0x47,0x5E};
flash char gcp16[15]={0x13,0x23,0x2D,0x33,0x38,0x3C,0x40,0x43,0x46,0x48,0x4A,0x4C,0x4E,0x50,0x64};

                    
#define DISP_W 132
#define DISP_H 176
#define CHAR_H 14
#define CHAR_W 8

//      
//unsigned int textcolor=GREEN;
unsigned int bgcolor=0x0000;
unsigned char tx,ty; //       lcd_rect 

char DISP_READY;

//     
void lcd_write8(char dat)
{
  spi(dat);
}
//   
void lcd_write(unsigned int dat)
{
  lcd_write8(dat>>8);
  lcd_write8 (dat);
}
//      (2 )
void lcd_d(unsigned int data)
{ 
  //CS=0;
  RS=1;
  lcd_write(data);
  RS=0;
  //CS=1;
} 
//   (2 )
void lcd_c(unsigned int command)
{ 
  //CS=0;
  RS=0;
  lcd_write(command);
  RS=1;
  //CS=1;
}

//      (1 )
void lcd_d8(unsigned char data)
{ 
  //CS=0;
  RS=1;
  lcd_write8(data);
  lcd_write8(0x00);
  RS=0;
  //CS=1;
} 
//   (1 )
void lcd_c8(unsigned char command)
{ 
  //CS=0;
  RS=0;
  lcd_write8(command);
  lcd_write8(0x00);
  RS=1;
  //CS=1;
}

void lcd_cspulse(void)
{
  CS=1;;
  #asm("nop");
  CS=0;
}
//    color
void fill_screen(unsigned int color)
{
 unsigned int i;

  CS=0;
 
  lcd_c8(SD_CSET);
  lcd_d8(0x08);  // start is 8, not 0
  lcd_d8(0x01);
  lcd_d8(0x8B);  // is 00x8B = 0x83+8
  lcd_d8(0x01);

  lcd_c8(SD_PSET);
  lcd_d8(0x00);
  lcd_d8(0xAF);

 
  lcd_c8(RAMWR);
  
  for (i=0; i<132*176; i++) 
    lcd_d(color);
   
    //delay_ms(100);};     //DISP_W 132  DISP_H 176      
  CS=1;
}

//   
void lcd_init(void)
{               
u08 i;
/*
  DISP_READY=0;
  
  //DDRB |= 0b11111100;
  //PORTB &= ~DDRB;
  // SPI initialization
  // SPI Type: Master
  //SPCR=0x50;SPSR=0x01;
  
  //RS=1 Command
  RESET=0;      //RS=0 DATA 
  CS=0;
  delay_ms(5);
  RS=1;
  RESET=1;
  delay_ms(50);
  for (i=0;i<5;i++) lcd_c(INIT1[i]);
  delay_ms(7);
  for (i=0;i<15;i++) lcd_c(INIT2[i]);
  delay_ms(50);
  for (i=0;i<17;i++) lcd_c(INIT3[i]);
  delay_ms(50);
  for (i=0;i<8;i++) lcd_c(INIT4[i]);
  delay_ms(5);
  
  fill_screen(bgcolor); //    
  CS=1;
  DISP_READY=1;
*/
  RESET=0; // reset display
  CS=1;  // CS is high during reset release
  RS=1;  // RS is set to high
  delay_ms(10);
  RESET=1;  // release reset
  delay_ms(35);

  CS=0;  // select display

  lcd_c8(DATCTL);
  lcd_d8(0x2A);  // 0x2A=565 mode, 0x0A=666mode, 0x3A=444mode

  lcd_cspulse();
  
  lcd_c8(DISCTL);
  for (i=0; i<9; i++)
  {
    lcd_d8(disctl[i]);
  }
  
  lcd_c8(GCP64);
  for (i=0; i<29; i++)
  {
    lcd_d8(gcp64_0[i]);
    lcd_d8(0x00);
  }
  for (i=0; i<34; i++)
  {
    lcd_d8(gcp64_1[i]);
    lcd_d8(0x01);
  }

  lcd_c8(GCP16);
  for (i=0; i<15; i++)
  {
    lcd_d8(gcp16[i]);
  }

  lcd_c8(GSSET);
  lcd_d8(0x00);

  lcd_c8(OSSEL);
  lcd_d8(0x00);

  lcd_c8(SLPOUT);
  
  delay_ms(7);
  
  lcd_c8(SD_CSET);
  lcd_d8(0x08);
  lcd_d8(0x01);
  lcd_d8(0x8B);
  lcd_d8(0x01);

  lcd_c8(SD_PSET);
  lcd_d8(0x00);
  lcd_d8(0x8F);


  lcd_c8(ASCSET);
  lcd_d8(0x00);
  lcd_d8(0xAF);
  lcd_d8(0xAF);
  lcd_d8(0x03);
  
  lcd_c8(SCSTART);
  lcd_d8(0x00);
  
  RS=0;
  lcd_c8(DISON);
  

  
  fill_screen(black);
  
  CS=1;  // deselect display


}

//     
void lcd_poweroff (void)
{
  lcd_c(0xEF00); lcd_c(0x7E04); lcd_c(0xEFB0); lcd_c(0x5A48); 
  lcd_c(0xEF00); lcd_c(0x7F01); lcd_c(0xEFB0); lcd_c(0x64FF);
  lcd_c(0x6500); lcd_c(0xEF00); lcd_c(0x7F01); lcd_c(0xE262);
  lcd_c(0xE202); lcd_c(0xEFB0); lcd_c(0xBC02); lcd_c(0xEF00);
  lcd_c(0x7F01); lcd_c(0xE200); lcd_c(0x8000); lcd_c(0xE204);
  lcd_c(0xE200); lcd_c(0xE100); lcd_c(0xEFB0); lcd_c(0xBC00);
  lcd_c(0xEF00); lcd_c(0x7F01);
}

//      (x,y),   color
void lcd_pixel (int x, int y, unsigned int color)
{
    CS=0;
    /*
    DISP_READY=0;
    lcd_c(0xEF90);    
    lcd_c(0x0500);
    lcd_c(0x0600+y);
    lcd_c(0x0700+DISP_H-x);
     lcd_d(color);
    DISP_READY=1;
    CS=1;
  */
  CS=0;
  lcd_c8(SD_CSET);
  lcd_d8(8+x);  // start is 8, not 0
  lcd_d8(1);
  lcd_d8(8+x);  // is 00x8B = 0x83+8
  lcd_d8(1);

  lcd_c8(SD_PSET);
  lcd_d8(y);
  lcd_d8(y+1);

 
  lcd_c8(RAMWR);
  lcd_d(color);
  CS=1;
}

//      
// m -  . 1- 
void put_char(char x, char y, char c, unsigned int color, unsigned int bcolor, char m)
{
  char h,ch,p,mask,he,n;
  
  
  
  CS=0;
   
  lcd_c8(SD_CSET);
  lcd_d8(0x08+x);  // start is 8, not 0
  lcd_d8(0x01);
  lcd_d8(0x08+x+(CHAR_W*m)-1);  // end is 00x8B = 0x83+8
  lcd_d8(0x01);
  
  lcd_c8(SD_PSET);
  lcd_d8(y);
 
    he=CHAR_H;
    lcd_d8(y+(CHAR_H*m)-1);
 

  lcd_c8(RAMWR);
  
for (h=0; h<he; h++) // every column of the character
  {     
        n=m;   
        ch=ascii_tab[ c ][h];
        sta:
        mask=0x80;
        for (p=0; p<(CHAR_W); p++)  // write the pixels
        {
          if (ch&mask)
          {
            lcd_d(color);
            if (m==2) lcd_d(color);
            if (m==3) {lcd_d(color); lcd_d(color);};               
          }
          else
          {
            lcd_d(bcolor);
            if (m==2) lcd_d(bcolor);
            if (m==3) {lcd_d(bcolor); lcd_d(bcolor);};  
          }
          mask=mask/2;
        }  // for p
        if ((m>1)&&(n>1)){n--; goto sta;}; 
  }



  CS=1;   
}

//  ,    x,y,  color
// m -  . 1- 
void put_string(unsigned char x, unsigned char y, char *str, unsigned int color, unsigned int bcolor, char m)
{
unsigned char  j=0;
  while (j<strlen(str))
   {
   put_char(x+j*CHAR_W*m,y,str[j],color,bcolor,m);   //  0 deg. rotated str[j]
   j++;
   }
} 

//  lcd    flash (    - "looL") 
// m -  . 1- 
void put_str_fl(unsigned char x, unsigned char y, u08 flash*str, ui16 color, unsigned int bcolor, char m)
 {
unsigned char  j=0;
   while ( *str !='\0')
     {
     put_char(x+j*CHAR_W*m,y,*str++,color,bcolor,m);
     j++;   
     }
}

//     
// m -  . 1- 
void put_ch(unsigned char x, unsigned char y, int ch, unsigned int color, unsigned int bcolor, char m)
{     
char buffer[16];
  if(ch>999)ch=999;
  itoa(ch, buffer); //   
  if(ch<100)
        put_char(x+CHAR_W*2*m,y,' ',bgcolor,bgcolor,m);
  if(ch<10) 
        put_char(x+CHAR_W*m,y,' ',bgcolor,bgcolor,m);
  put_string(x,y,buffer,color,bcolor,m);    
} 

//       
// m -  . 1- 
void put_parametr(unsigned char x, unsigned char y, u08 flash*str1, int ch, u08 flash*str2, unsigned int color, unsigned int bcolor, char m)
{          
char buffer[16];
char j=0;

  while ( *str1 !='\0')
     {
     put_char(x+j*CHAR_W*m,y,*str1++,color,bcolor,m);
     j++;   
     }
  x += j*CHAR_W*m;
  if(ch>999)ch=999;
  itoa(ch, buffer); //   
  if(ch<100)
        put_char(x+CHAR_W*2,y,' ',bgcolor,bgcolor,m); 
  if(ch<10) 
        put_char(x+CHAR_W,y,' ',bgcolor,bgcolor,m); 
  put_string(x,y,buffer,color,bcolor,m);
  j=3;
  while ( *str2 !='\0')
     {
     put_char(x+j*CHAR_W*m,y,*str2++,color,bcolor,m);
     j++;   
     } 
}

//  
void lcd_line ( int x1, int y1, int x2, int y2, unsigned int color )
{   
    int dx, dy, stepx, stepy, fraction;       
    DISP_READY=0;
    //x1=DISP_W - x1;
    //x2=DISP_W - x2;
    dy = y2 - y1;
    dx = x2 - x1;
    if ( dy < 0 )
    {
        dy    = -dy;
        stepy = -1;
    }
    else
    {
        stepy = 1;
    }

    if ( dx < 0 )
    {
        dx    = -dx;
        stepx = -1;
    }
    else
    {
        stepx = 1;
    }
    dx <<= 1;
    dy <<= 1;
    
    if ( dx > dy )
    {
        fraction = dy - (dx >> 1);
        while ( x1 != x2 )
        {
            if ( fraction >= 0 )
            {
                y1 += stepy;
                fraction -= dx;
            }
            x1 += stepx;
            fraction += dy;
              lcd_pixel(x1,y1,color);//     
        }
    }
    else
    {
        fraction = dx - (dy >> 1);
        while ( y1 != y2 )
        {
            if ( fraction >= 0 )
            {
                x1 += stepx;
                fraction -= dy;
            }
            y1 += stepy;
            fraction += dx;
              lcd_pixel(x1,y1,color);//     
        }
    }
    DISP_READY=1;
}

//   
void lcd_circle(u08 xcenter, u08 ycenter, si16 rad, ui16 color)
{
  si16 tswitch,y1,x1 = 0;
  u08 d;
  DISP_READY=0;
  //xcenter = DISP_H - xcenter;
  d = ycenter - xcenter;
  y1 = rad;
  tswitch = 3 - 2 * rad;
  while (x1 <= y1) 
  {
    lcd_pixel(xcenter + x1, ycenter + y1, color); 
    lcd_pixel(xcenter + x1, ycenter - y1, color);
    lcd_pixel(xcenter - x1, ycenter + y1, color);   
    lcd_pixel(xcenter - x1, ycenter - y1, color);
    lcd_pixel(ycenter + y1 - d, ycenter + x1, color); 
    lcd_pixel(ycenter + y1 - d, ycenter - x1, color);
    lcd_pixel(ycenter - y1 - d, ycenter + x1, color);
    lcd_pixel(ycenter - y1 - d, ycenter - x1, color);
    if (tswitch < 0) tswitch += (4 * x1 + 6);
     else 
      {
      tswitch += (4 * (x1 - y1) + 10);
      y1--;
      }
    x1++;
  }            
  DISP_READY=1;
}  


void lcd_rect(int x1, int y1, int x2, int y2, int color,)
{     
     int i; 
     CS=0; 
  lcd_c8(SD_CSET);
  lcd_d8(8+x1);  // start is 8, not 0
  lcd_d8(0x01);
  lcd_d8(8+x2);  // is 00x8B = 0x83+8
  lcd_d8(0x01);

  lcd_c8(SD_PSET);
  lcd_d8(y1);
  lcd_d8(y2);

 
  lcd_c8(RAMWR);
  for (i=0; i<((x2-x1)*(y2-y1+1)); i++)
  lcd_d(color);
     CS=1;     
} 

void lcd_fill(char x,char y,char w,char h,int color){
 unsigned int i,j;
  CS=0;
 
  lcd_c8(SD_CSET);
  lcd_d8(0x08+x);  // start is 8, not 0
  lcd_d8(0x01);
  lcd_d8(0x08+x+w);  // is 00x8B = 0x83+8
  lcd_d8(0x01);

  lcd_c8(SD_PSET);
  lcd_d8(y);
  lcd_d8(y+h);

 
  lcd_c8(RAMWR);
  
  
  lcd_c8(RAMWR);
  for (i=0; i<((w+1)*h); i++)
  lcd_d(color);   
  CS=1;    
}

void lcd_picture(unsigned char x, unsigned char y, unsigned char w, unsigned char h, flash unsigned int *pic){
 unsigned int i,j;
CS=0;
 
  lcd_c8(SD_CSET);
  lcd_d8(0x08+x);  // start is 8, not 0
  lcd_d8(0x01);
  lcd_d8(0x08+x+w);  // is 00x8B = 0x83+8
  lcd_d8(0x01);

  lcd_c8(SD_PSET);
  lcd_d8(y);
  lcd_d8(y+h);

 
  lcd_c8(RAMWR);
  
  
 for(i=0; i<h; i++) //lcd_d(pic[i]); 
  for (j=w; j>0; j--)
    lcd_d(pic[i*w+j-1]);    
  CS=1;
}